"use strict";
var b = require('bobril');
var container_1 = require('./container');
var toggleButton_1 = require('./toggleButton');
var h = require('./bobrilHelpers');
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = b.createComponent({
    render: function (ctx, me) {
        me.tag = 'nav';
        me.className = 'navbar navbar-default navbar-fixed-top';
        me.children = container_1.default({
            isFluid: true,
            content: [
                styledDiv([
                    toggleButton_1.default({}),
                    styledDiv([ctx.data.header], 'navbar-brand')
                ], 'navbar-header'),
                styledDiv([
                    styledUl(ctx.data.routes.map(function (r) { return h.styledLi({ content: r.label, onClick: r.onRoute, isActive: b.isActive(r.value) || r.value === ctx.data.activeRoute }); }), 'nav navbar-nav'),
                    styledUl([
                        h.styledLi({ content: ctx.data.userName }),
                        h.styledLi({ content: 'Odhlasit', onClick: ctx.data.onLogout })
                    ], 'nav navbar-nav navbar-right')
                ], 'navbar-collapse collapse')
            ]
        });
    }
});
function styledDiv(content, className) {
    return {
        tag: 'div',
        className: className,
        children: content
    };
}
function styledUl(content, className) {
    return {
        tag: 'ul',
        className: className,
        children: content
    };
}
